# coding: utf-8

"""
    RadioManager

    RadioManager

    OpenAPI spec version: 2.0
    Contact: support@pluxbox.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..api_client import ApiClient


class ModelTypeApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_model_type_by_id(self, id, **kwargs):
        """
        Get modelType by id
        Get modelType by id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_model_type_by_id(id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int id: ID of ModelType **(Required)** (required)
        :param int external_station_id: Query on a different (content providing) station *(Optional)*
        :return: ModelTypeResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_model_type_by_id_with_http_info(id, **kwargs)
        else:
            (data) = self.get_model_type_by_id_with_http_info(id, **kwargs)
            return data

    def get_model_type_by_id_with_http_info(self, id, **kwargs):
        """
        Get modelType by id
        Get modelType by id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_model_type_by_id_with_http_info(id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int id: ID of ModelType **(Required)** (required)
        :param int external_station_id: Query on a different (content providing) station *(Optional)*
        :return: ModelTypeResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'external_station_id']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_model_type_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_model_type_by_id`")

        if 'id' in params and params['id'] < 0:
            raise ValueError("Invalid value for parameter `id` when calling `get_model_type_by_id`, must be a value greater than or equal to `0`")

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = []
        if 'external_station_id' in params:
            query_params.append(('_external_station_id', params['external_station_id']))

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['API Key']

        return self.api_client.call_api('/model_types/{id}', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ModelTypeResult',
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def list_model_types(self, **kwargs):
        """
        Get all modelTypes.
        List all modelTypes.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.list_model_types(async=True)
        >>> result = thread.get()

        :param async bool
        :param int page: Current page *(Optional)*
        :param str model:
        :param int program_id: Search on Program ID *(Optional)*
        :param int broadcast_id: Search on Broadcast ID *(Optional)*
        :param int item_id: Search on Item ID *(Optional)*
        :param int campaign_id: Search on Campaign ID *(Optional)*
        :param int presenter_id: Search on Presenter ID *(Optional)*
        :param int contact_id: Search on Contact ID *(Optional)*
        :param int external_station_id: Query on a different (content providing) station *(Optional)*
        :return: ModelTypeResults
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.list_model_types_with_http_info(**kwargs)
        else:
            (data) = self.list_model_types_with_http_info(**kwargs)
            return data

    def list_model_types_with_http_info(self, **kwargs):
        """
        Get all modelTypes.
        List all modelTypes.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.list_model_types_with_http_info(async=True)
        >>> result = thread.get()

        :param async bool
        :param int page: Current page *(Optional)*
        :param str model:
        :param int program_id: Search on Program ID *(Optional)*
        :param int broadcast_id: Search on Broadcast ID *(Optional)*
        :param int item_id: Search on Item ID *(Optional)*
        :param int campaign_id: Search on Campaign ID *(Optional)*
        :param int presenter_id: Search on Presenter ID *(Optional)*
        :param int contact_id: Search on Contact ID *(Optional)*
        :param int external_station_id: Query on a different (content providing) station *(Optional)*
        :return: ModelTypeResults
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['page', 'model', 'program_id', 'broadcast_id', 'item_id', 'campaign_id', 'presenter_id', 'contact_id', 'external_station_id']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_model_types" % key
                )
            params[key] = val
        del params['kwargs']

        if 'page' in params and params['page'] < 0:
            raise ValueError("Invalid value for parameter `page` when calling `list_model_types`, must be a value greater than or equal to `0`")

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))
        if 'model' in params:
            query_params.append(('model', params['model']))
        if 'program_id' in params:
            query_params.append(('program_id', params['program_id']))
        if 'broadcast_id' in params:
            query_params.append(('broadcast_id', params['broadcast_id']))
        if 'item_id' in params:
            query_params.append(('item_id', params['item_id']))
        if 'campaign_id' in params:
            query_params.append(('campaign_id', params['campaign_id']))
        if 'presenter_id' in params:
            query_params.append(('presenter_id', params['presenter_id']))
        if 'contact_id' in params:
            query_params.append(('contact_id', params['contact_id']))
        if 'external_station_id' in params:
            query_params.append(('_external_station_id', params['external_station_id']))

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['API Key']

        return self.api_client.call_api('/model_types', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ModelTypeResults',
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
